var fs = require('fs');
var path = require("path");

module.exports = function(templateDir, staticDir, webpackFlag) {

  // start the socket server
  var app = require('express')();
  var server = require('http').Server(app);
  var io = require('socket.io')(server);

  server.listen(5000);

  app.get('/livereload.js', function(req, res) {
    res.sendFile(path.join(__dirname, '../', 'client/livereload.js'));
  })

  app.get('/client.js', function(req, res) {
    res.sendFile(path.join(__dirname, '../', 'client/socket.client.js'));
  })

  io.on('connection', function(socket) {

  });

  // watch file changes
  fs.watch(process.cwd() + templateDir, {
    encoding: 'utf8',
    recursive: true
  }, (event, filename) => {
    if (/html/.test(filename)) {
      io.emit('htmlChange', {});
    } 
  });

  if (!webpackFlag && staticDir) {
    fs.watch(process.cwd() + staticDir, {
      encoding: 'utf8',
      recursive: true
    }, (event, filename) => {
      if (/css/.test(filename)) {
        io.emit('cssChange', {});
      }
    });

    fs.watch(process.cwd() + staticDir, {
      encoding: 'utf8',
      recursive: true
    }, (event, filename) => {
      if (/js/.test(filename)) {
        io.emit('jsChange', {});
      }
    });
  }

}
